diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 51ae70bf7..ef2f5e185 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -7,7 +7,6 @@ import java.util.*;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
-import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.option.GameSettings;
@@ -18,14 +17,13 @@ import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorShader;
 import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.block.BlockLogicPortal;
-import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
-import org.jetbrains.annotations.NotNull;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.hud.component.HudComponent;
@@ -49,18 +47,21 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.ChatLine;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.wind.WindProvider;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class HudIngame extends Gui {
     public static final float DEBUG_SCALE = 1f;
+    protected static final @NotNull TessellatorGeneral hudTessellater = new TessellatorShader("Hud Tessellator", 8192);
+    protected static final @NotNull StringBuilder hudBuilder = new StringBuilder(256);
+
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final Direction[] directions = new Direction[]{Direction.NORTH, Direction.EAST, Direction.SOUTH, Direction.WEST};
 
@@ -89,7 +90,7 @@ public class HudIngame extends Gui {
     public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY) {
         if (this.mc.currentScreen instanceof ScreenPhotoMode) return;
 
-        I18n stringtranslate = I18n.getInstance();
+        I18n i18n = I18n.getInstance();
         int width = this.mc.resolution.getScaledWidthScreenCoords();
         int height = this.mc.resolution.getScaledHeightScreenCoords();
         this.mc.worldRenderer.setupScaledResolution();
@@ -190,27 +191,32 @@ public class HudIngame extends Gui {
 
                 int space = 6;
 
-                drawDebugScreenLineRight("Used memory: " + (memUsed * 100L) / memMax + "% (" + memUsed / 1024L / 1024L + "MB) of " + memMax / 1024L / 1024L + "MB");
-                drawDebugScreenLineRight("Allocated memory: " + (memTotal * 100L) / memMax + "% (" + memTotal / 1024L / 1024L + "MB)");
-                drawDebugScreenLineRight("JRE: " + System.getProperty("java.version") + " (" + System.getProperty("java.vendor") + ")");
-                drawDebugScreenLineRight("LWJGL version: " + org.lwjgl.Version.getVersion());
+                hudTessellater.startDrawingQuads();
+                hudBuilder.setLength(0);
+
+                this.fontRenderer.startDrawingDeferred();
+
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Used memory: ").append((memUsed * 100L) / memMax).append("% (").append(memUsed / 1024L / 1024L).append("MB) of ").append(memMax / 1024L / 1024L).append("MB")); hudBuilder.setLength(0);
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Allocated memory: ").append((memTotal * 100L) / memMax).append("% (").append(memTotal / 1024L / 1024L).append("MB)")); hudBuilder.setLength(0);
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("JRE: ").append(System.getProperty("java.version")).append(" (").append(System.getProperty("java.vendor")).append(")")); hudBuilder.setLength(0);
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("LWJGL version: ").append(org.lwjgl.Version.getVersion())); hudBuilder.setLength(0);
 
                 this.debugOffsetRight += space;
 
-                drawDebugScreenLineRight(OpenGLHelper.vendor);
-                drawDebugScreenLineRight(OpenGLHelper.renderer);
-                drawDebugScreenLineRight(OpenGLHelper.version);
-                drawDebugScreenLineRight(String.format("OpenGL %s.%s", GL41.glGetInteger(GL41.GL_MAJOR_VERSION), GL41.glGetInteger(GL41.GL_MINOR_VERSION)));
+                drawDebugScreenLineRight(hudTessellater, OpenGLHelper.vendor);
+                drawDebugScreenLineRight(hudTessellater, OpenGLHelper.renderer);
+                drawDebugScreenLineRight(hudTessellater, OpenGLHelper.version);
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("OpenGL ").append(GL41.glGetInteger(GL41.GL_MAJOR_VERSION)).append(".").append(GL41.glGetInteger(GL41.GL_MINOR_VERSION))); hudBuilder.setLength(0);
                 long availableVRam = OpenGLHelper.availableVRam();
                 long totalVRam = OpenGLHelper.totalVRam();
                 if (totalVRam != -1 || availableVRam != -1) {
-                    drawDebugScreenLineRight(String.format("Available Video Memory (%sMB) of %sMB", (availableVRam / 1024), (totalVRam / 1024)));
+                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Available Video Memory (").append(availableVRam / 1024).append("MB) of ").append(totalVRam / 1024).append("MB")); hudBuilder.setLength(0);
                 }
-                drawDebugScreenLineRight("Resolution: " + this.mc.gameWindow.getWidthPixels() + "x" + this.mc.gameWindow.getHeightPixels());
-                drawDebugScreenLineRight("Render Resolution: " + this.mc.renderer.getRenderWidth() + "x" + this.mc.renderer.getRenderHeight());
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Resolution: ").append(this.mc.gameWindow.getWidthPixels()).append("x").append(this.mc.gameWindow.getHeightPixels())); hudBuilder.setLength(0);
+                drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Render Resolution: ").append(this.mc.renderer.getRenderWidth()).append("x").append(this.mc.renderer.getRenderHeight())); hudBuilder.setLength(0);
 
-                drawDebugScreenLine("Better than Adventure! " + Minecraft.VERSION);
-                drawDebugScreenLine(this.mc.lineDebug);
+                drawDebugScreenLine(hudTessellater, hudBuilder.append("Better than Adventure! ").append(Minecraft.VERSION)); hudBuilder.setLength(0);
+                drawDebugScreenLine(hudTessellater, this.mc.lineDebug);
                 if (this.mc.terrainRenderer instanceof TerrainRendererMultiDraw terrainRenderer) {
 
                     int regionCount = terrainRenderer.regionBuffer.size();
@@ -223,9 +229,9 @@ public class HudIngame extends Gui {
                     int totalEntries = 0;
                     int visibleEntries = 0;
                     for (int i = 0; i < allRegions.size(); i++) {
-                        RenderRegion region = allRegions.get(i);
+                        RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> region = allRegions.get(i);
                         for (int j = 0; j < region.renderLists.length; j++) {
-                            RenderList renderList = region.renderLists[j];
+                            RenderList<TessellatorTerrainImpl.TerrainVertexConfig> renderList = region.renderLists[j];
                             if (renderList == null) {
                                 continue;
                             }
@@ -234,46 +240,46 @@ public class HudIngame extends Gui {
                         }
                     }
 
-                    drawDebugScreenLine("R: " + regionCount + " D: " + terrainRenderer.getTotalDrawCalls() + " T: " + visibleEntries + "/" + totalEntries + " VBO: " + terrainRenderer.vertexBuffer.entryCount());
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("R: ").append(regionCount).append(" D: ").append(terrainRenderer.getTotalDrawCalls()).append(" T: ").append(visibleEntries).append("/").append(totalEntries).append(" VBO: ").append(terrainRenderer.vertexBuffer.entryCount())); hudBuilder.setLength(0);
 
-                    RenderRegion currentRegion = terrainRenderer.getRenderRegionAtBlockPos(playerX, playerZ);
+                    RenderRegion<TessellatorTerrainImpl.TerrainVertexConfig> currentRegion = terrainRenderer.getRenderRegionAtBlockPos(playerX, playerZ);
                     totalEntries = 0;
                     visibleEntries = 0;
                     for (int j = 0; j < currentRegion.renderLists.length; j++) {
-                        RenderList renderList = currentRegion.renderLists[j];
+                        RenderList<TessellatorTerrainImpl.TerrainVertexConfig> renderList = currentRegion.renderLists[j];
                         if (renderList == null) {
                             continue;
                         }
                         totalEntries += renderList.size();
                         visibleEntries += renderList.visibleEntryCount();
                     }
-                    drawDebugScreenLine("CR: " + currentRegion + " E: " + visibleEntries + "/" + totalEntries);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("CR: ").append(currentRegion).append(" E: ").append(visibleEntries).append("/").append(totalEntries)); hudBuilder.setLength(0);
 
                 } else {
-                    drawDebugScreenLine(this.mc.getRendererDebugInfo());
+                    drawDebugScreenLine(hudTessellater, this.mc.getRendererDebugInfo());
                 }
-                drawDebugScreenLine(this.mc.getEntityDebugInfoString());
-                drawDebugScreenLine(this.mc.getEntityCountsInfoString());
-                drawDebugScreenLine(this.mc.getChunkProviderInfoString());
+                drawDebugScreenLine(hudTessellater, this.mc.getEntityDebugInfoString());
+                drawDebugScreenLine(hudTessellater, this.mc.getEntityCountsInfoString());
+                drawDebugScreenLine(hudTessellater, this.mc.getChunkProviderInfoString());
 
                 this.debugOffset += space;
                 this.debugOffsetRight += space;
 
                 if (compass) {
-                    drawDebugScreenLine("X: " + this.mc.thePlayer.x);
-                    drawDebugScreenLine("Y: " + this.mc.thePlayer.y);
-                    drawDebugScreenLine("Z: " + this.mc.thePlayer.z);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("X: ").append(this.mc.thePlayer.x)); hudBuilder.setLength(0);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Y: ").append(this.mc.thePlayer.y)); hudBuilder.setLength(0);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Z: ").append(this.mc.thePlayer.z)); hudBuilder.setLength(0);
 
                     int chunkX = MathHelper.floor(this.mc.thePlayer.x) >> 4;
                     int chunkZ = MathHelper.floor(this.mc.thePlayer.z) >> 4;
 
-                    drawDebugScreenLine("Chunk: " + chunkX + ", " + chunkZ);
+                    drawDebugScreenLine(hudTessellater, "Chunk: " + chunkX + ", " + chunkZ);
 
-                    int yaw = DynamicTexture.pmod(java.lang.Math.round(this.mc.thePlayer.yRot), 360);
+                    int yaw = Math.floorMod(java.lang.Math.round(this.mc.thePlayer.yRot), 360);
                     int pitch = java.lang.Math.round(this.mc.thePlayer.xRot);
-                    drawDebugScreenLine("Facing: " + yaw + "°, " + pitch + "° (" + I18n.getInstance().translateKey(getFacingDirection(this.mc.thePlayer).translationKey) + ")");
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Facing: ").append(yaw).append("°, ").append(pitch).append("° (").append(I18n.getInstance().translateKey(getFacingDirection(this.mc.thePlayer).translationKey)).append(")")); hudBuilder.setLength(0);
                 } else {
-                    drawDebugScreenLine("Hold a compass for more information");
+                    drawDebugScreenLine(hudTessellater, "Hold a compass for more information");
                 }
 
                 if (clock) {
@@ -282,20 +288,20 @@ public class HudIngame extends Gui {
                     int playerX = MathHelper.floor(this.mc.thePlayer.x);
                     int playerY = MathHelper.floor(this.mc.thePlayer.y);
                     int playerZ = MathHelper.floor(this.mc.thePlayer.z);
-                    drawDebugScreenLine("Light: Sky: " + this.mc.currentWorld.getSavedLightValue(LightLayer.Sky, playerX, playerY, playerZ) + " Block: " + this.mc.currentWorld.getSavedLightValue(LightLayer.Block, playerX, playerY, playerZ));
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Light: Sky: ").append(this.mc.currentWorld.getSavedLightValue(LightLayer.Sky, playerX, playerY, playerZ)).append(" Block: ").append(this.mc.currentWorld.getSavedLightValue(LightLayer.Block, playerX, playerY, playerZ))); hudBuilder.setLength(0);
                 }
 
                 this.debugOffset += space;
 
-                drawDebugScreenLine("Entities: " + this.mc.currentWorld.getLoadedEntityList().size());
-                drawDebugScreenLine("Tile Entities: " + this.mc.currentWorld.getLoadedTileEntityList().size());
+                drawDebugScreenLine(hudTessellater, hudBuilder.append("Entities: ").append(this.mc.currentWorld.getLoadedEntityList().size())); hudBuilder.setLength(0);
+                drawDebugScreenLine(hudTessellater, hudBuilder.append("Tile Entities: ").append(this.mc.currentWorld.getLoadedTileEntityList().size())); hudBuilder.setLength(0);
 
                 this.debugOffset += space;
 
                 if (clock) {
-                    drawDebugScreenLine("Time: " + getTimeString(this.mc) + " (Day " + (this.mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS) + ")");
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Time: ").append(getTimeString(this.mc)).append(" (Day ").append(this.mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS).append(")")); hudBuilder.setLength(0);
                 } else {
-                    drawDebugScreenLine("Hold a clock for more information");
+                    drawDebugScreenLine(hudTessellater, "Hold a clock for more information");
                 }
 
                 this.debugOffset += space;
@@ -304,47 +310,47 @@ public class HudIngame extends Gui {
                     Season season = this.mc.currentWorld.getSeasonManager().getCurrentSeason();
                     String seasonString = season != null ? season.getTranslatedName() : "None";
                     Weather weather = this.mc.currentWorld.getCurrentWeather();
-                    String weatherString = weather != null ? stringtranslate.translateKey(weather.getNameLanguageKey()) : "None";
+                    String weatherString = weather != null ? i18n.translateKey(weather.getNameLanguageKey()) : "None";
 
                     int blockX = MathHelper.floor(this.mc.thePlayer.x);
                     int blockY = MathHelper.floor(this.mc.thePlayer.y);
                     int blockZ = MathHelper.floor(this.mc.thePlayer.z);
 
-                    drawDebugScreenLine("Season: " + seasonString);
-                    drawDebugScreenLine("Weather: " + weatherString + " (" + (this.mc.currentWorld.getWeatherManager().getWeatherDuration() / 20) + "s I: " + percentRound(this.mc.currentWorld.getWeatherManager().getWeatherIntensity()) + "% P: " + percentRound(this.mc.currentWorld.getWeatherManager().getWeatherPower()) + "%)");
-                    drawDebugScreenLine("Biome: " + Registries.BIOMES.getKey(this.mc.currentWorld.getBlockBiome(blockX, blockY, blockZ)));
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Season: ").append(seasonString)); hudBuilder.setLength(0);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Weather: ").append(weatherString).append(" (").append(this.mc.currentWorld.getWeatherManager().getWeatherDuration() / 20).append("s I: ").append(percentRound(this.mc.currentWorld.getWeatherManager().getWeatherIntensity())).append("% P: ").append(percentRound(this.mc.currentWorld.getWeatherManager().getWeatherPower())).append("%)")); hudBuilder.setLength(0);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Biome: ").append(Registries.BIOMES.getKey(this.mc.currentWorld.getBlockBiome(blockX, blockY, blockZ)))); hudBuilder.setLength(0);
 
                     float temperature = (float) floor100(this.mc.currentWorld.getBlockTemperature(blockX, blockZ));
                     float humidity = (float) floor100(this.mc.currentWorld.getBlockHumidity(blockX, blockZ));
 
-                    drawDebugScreenLine("Temperature: " + temperature + " Humidity: " + humidity);
+                    drawDebugScreenLine(hudTessellater, hudBuilder.append("Temperature: ").append(temperature).append(" Humidity: ").append(humidity)); hudBuilder.setLength(0);
 
                     WindProvider windProvider = this.mc.currentWorld.getWorldType().getWindManager();
                     if (windProvider != null) {
                         float direction = (float) floor100(windProvider.getWindDirection(this.mc.currentWorld, 0.0f, 500.0f, 0.0f));
                         float intensity = (float) floor100(windProvider.getWindIntensity(this.mc.currentWorld, 0.0f, 500.0f, 0.0f));
 
-                        int yaw = DynamicTexture.pmod(java.lang.Math.round((direction * 360.0f) + 270.0f), 360);
-                        drawDebugScreenLine("Wind: " + yaw + "°, " + java.lang.Math.round(intensity * 100.0f) + "%");
+                        int yaw = Math.floorMod(java.lang.Math.round((direction * 360.0f) + 270.0f), 360);
+                        drawDebugScreenLine(hudTessellater, hudBuilder.append("Wind: ").append(yaw).append("°, ").append(Math.round(intensity * 100.0f)).append("%")); hudBuilder.setLength(0);
                     }
                 } else {
-                    drawDebugScreenLine("Hold a rotary calendar for more information");
+                    drawDebugScreenLine(hudTessellater, "Hold a rotary calendar for more information");
                 }
 
                 this.debugOffset += space;
 
-                drawDebugScreenLine("Seed: " + this.mc.currentWorld.getRandomSeed());
+                drawDebugScreenLine(hudTessellater, hudBuilder.append("Seed: ").append(this.mc.currentWorld.getRandomSeed())); hudBuilder.setLength(0);
 
                 this.debugOffset += space;
 
-                drawDebugScreenLine("CTRL + F3: Show Frametimes");
-                drawDebugScreenLine("F3 + Q: Show Keyboard Shortcuts");
+                drawDebugScreenLine(hudTessellater, "CTRL + F3: Show Frametimes");
+                drawDebugScreenLine(hudTessellater, "F3 + Q: Show Keyboard Shortcuts");
 
                 if (this.mc.objectMouseOver instanceof HitResult.Tile hitTile) {
                     this.debugOffset += space;
 
                     Block<?> block = this.mc.currentWorld.getBlockType(hitTile.tilePos);
-                    drawDebugScreenLineRight("Looking at:");
+                    drawDebugScreenLineRight(hudTessellater, "Looking at:");
 
                     String name;
                     int meta = this.mc.currentWorld.getBlockData(hitTile.tilePos);
@@ -356,15 +362,15 @@ public class HudIngame extends Gui {
 
                     String id = block.namespaceId() + " [" + block.id() + ":" + meta + "]";
 
-                    drawDebugScreenLineRight(name);
-                    drawDebugScreenLineRight(block.getLanguageKey(meta));
-                    drawDebugScreenLineRight(id);
+                    drawDebugScreenLineRight(hudTessellater, name);
+                    drawDebugScreenLineRight(hudTessellater, block.getLanguageKey(meta));
+                    drawDebugScreenLineRight(hudTessellater, id);
 
                     if (compass) {
-                        drawDebugScreenLineRight("[" + hitTile.tilePos.x() + ", " + hitTile.tilePos.y() + ", " + hitTile.tilePos.z() + "]");
+                        drawDebugScreenLineRight(hudTessellater, hudBuilder.append("[").append(hitTile.tilePos.x()).append(", ").append(hitTile.tilePos.y()).append(", ").append(hitTile.tilePos.z()).append("]")); hudBuilder.setLength(0);
                     }
 
-                    drawDebugScreenLineRight("Harvest: " + this.mc.thePlayer.canHarvestBlock(block));
+                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Harvest: ").append(this.mc.thePlayer.canHarvestBlock(block))); hudBuilder.setLength(0);
 
                     if (clock) {
                         int lightX = hitTile.tilePos.x();
@@ -376,18 +382,27 @@ public class HudIngame extends Gui {
                         lightY += side.offsetY();
                         lightZ += side.offsetZ();
 
-                        drawDebugScreenLineRight("Light: Sky: " + this.mc.currentWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ) + " Block: " + this.mc.currentWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ));
+                        drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Light: Sky: ").append(this.mc.currentWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ)).append(" Block: ").append(this.mc.currentWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ))); hudBuilder.setLength(0);
                     }
 
-                    drawDebugScreenLineRight("Signal: " + this.mc.currentWorld.hasSignal(hitTile.tilePos, hitTile.side));
-                    drawDebugScreenLineRight("Direct signal: " + this.mc.currentWorld.hasDirectSignal(hitTile.tilePos, hitTile.side));
+                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Signal: ").append(this.mc.currentWorld.hasSignal(hitTile.tilePos, hitTile.side))); hudBuilder.setLength(0);
+                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Direct signal: ").append(this.mc.currentWorld.hasDirectSignal(hitTile.tilePos, hitTile.side))); hudBuilder.setLength(0);
 
                     for (Tag<Block<?>> tag : BlockTags.TAG_LIST) {
                         if (tag.appliesTo(block)) {
-                            drawDebugScreenLineRight(tag.getName());
+                            drawDebugScreenLineRight(hudTessellater, tag.getName());
                         }
                     }
                 }
+
+                GLRenderer.pushFrame();
+                GLRenderer.setShader(Shaders.COLOR);
+                GLRenderer.setColor4f(0.2f, 0.2f, 0.2f, 0.6f);
+                hudTessellater.draw();
+                GLRenderer.popFrame();
+
+                this.fontRenderer.draw(this.zLevel);
+
                 GLRenderer.popFrame();
             }
         }
@@ -400,7 +415,7 @@ public class HudIngame extends Gui {
 
             TessellatorGeneral tessellator = GLRenderer.getTessellator();
 
-            TextureRegistry.worldAtlas.bind(TextureRegistry.worldAtlas.idToLayerMap.get(mc.debugAtlasLayer));
+            TextureRegistry.worldAtlas.bind(TextureRegistry.worldAtlas.idToLayerMap.get(this.mc.debugAtlasLayer));
 
 
             int blockW = TextureRegistry.worldAtlas.getAtlasWidth();
@@ -428,35 +443,25 @@ public class HudIngame extends Gui {
 
     private final int debugLineHeight = 10;
 
-    private void drawDebugScreenLine(final CharSequence string, final boolean right, final int line, final int offset) {
+    private void drawDebugScreenLine(final @NotNull TessellatorGeneral tessellator, final @NotNull CharSequence string, final boolean right, final int line, final int offset) {
         int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(string));
         int height = this.debugLineHeight;
         int x = right ? (int) ((this.mc.resolution.getScaledWidthScreenCoords() / DEBUG_SCALE) - width - 2) : 2;
         int y = 3 + line * this.debugLineHeight + offset;
 
-        GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.COLOR);
-        GLRenderer.setColor4f(0.2f, 0.2f, 0.2f, 0.6f);
-        final TessellatorGeneral t = GLRenderer.getTessellator();
-
-        t.startDrawingQuads();
-        t.drawRectangle(x - 1, y - 1, width + 2, height);
-        t.draw();
-        GLRenderer.popFrame();
-
-//		fontrenderer.drawStringWithShadow(string, x, y, 0xFFFFFF);
-        drawStringNoShadow(this.fontRenderer, string, x, y, 0xFFFFFF);
+        tessellator.drawRectangle(x - 1, y - 1, width + 2, height);
+        this.fontRenderer.render(string, x, y).setColor(0xFFFFFF).call();
     }
 
-    private void drawDebugScreenLine(final CharSequence string) {
-        drawDebugScreenLine(string, false, this.debugLine++, this.debugOffset);
+    private void drawDebugScreenLine(final @NotNull TessellatorGeneral tessellator, final @NotNull CharSequence string) {
+        drawDebugScreenLine(tessellator, string, false, this.debugLine++, this.debugOffset);
     }
 
-    private void drawDebugScreenLineRight(final CharSequence string) {
-        drawDebugScreenLine(string, true, this.debugLineRight++, this.debugOffsetRight);
+    private void drawDebugScreenLineRight(final @NotNull TessellatorGeneral tessellator, final @NotNull CharSequence string) {
+        drawDebugScreenLine(tessellator, string, true, this.debugLineRight++, this.debugOffsetRight);
     }
 
-    private final List<String> playerListScoreStrings = new ArrayList<>();
+//    private final List<String> playerListScoreStrings = new ArrayList<>();
 
     public void drawPlayerList(int screenWidth, int screenHeight) {
         if (!this.mc.isMultiplayerWorld()) return;
@@ -479,13 +484,13 @@ public class HudIngame extends Gui {
         int longestNameWidth = 0;
         int longestScoreWidth = 0;
 
-        this.playerListScoreStrings.clear();
+//        this.playerListScoreStrings.clear();
 
         for (Map.Entry<String, String> a1 : players.entrySet()) {
             longestNameWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(a1.getKey())), longestNameWidth);
 
             longestScoreWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(a1.getValue())), longestScoreWidth);
-            this.playerListScoreStrings.add(a1.getValue());
+//            this.playerListScoreStrings.add(a1.getValue());
         }
 
         final int nameScoreSpace = 4;
@@ -599,7 +604,7 @@ public class HudIngame extends Gui {
 
     protected void renderVignette(float intensity, int xSize, int ySize) {
         intensity = MathHelper.clamp(1.0f - intensity, 0.0f, 1.0f);
-        this.prevVignetteBrightness += (double) (intensity - this.prevVignetteBrightness) * 0.01D;
+        this.prevVignetteBrightness += (intensity - this.prevVignetteBrightness) * 0.01f;
         GLRenderer.disableState(State.DEPTH_TEST);
         GLRenderer.setDepthMask(false);
         GLRenderer.setBlendFunc(BlendFactor.ZERO, BlendFactor.ONE_MINUS_SRC_COLOR);
@@ -630,16 +635,16 @@ public class HudIngame extends Gui {
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, intensity);
         IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(this.mc.thePlayer.portalID)).getOverlayTexture(this.mc.thePlayer.portalColor.blockMeta << 4 | BlockLogicPortal.MASK_COLOR_SET);
         portal.parentAtlas.bind();
-        float f1 = (float) portal.getIconUMin();
-        float f2 = (float) portal.getIconVMin();
-        float f3 = (float) portal.getIconUMax();
-        float f4 = (float) portal.getIconVMax();
+        float uMin = (float) portal.getIconUMin();
+        float vMin = (float) portal.getIconVMin();
+        float uMax = (float) portal.getIconUMax();
+        float vMax = (float) portal.getIconVMax();
         TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(0.0D, ySize, -90D, f1, f4);
-        tessellator.addVertexWithUV(xSize, ySize, -90D, f3, f4);
-        tessellator.addVertexWithUV(xSize, 0.0D, -90D, f3, f2);
-        tessellator.addVertexWithUV(0.0D, 0.0D, -90D, f1, f2);
+        tessellator.addVertexWithUV(0.0D, ySize, -90D, uMin, vMax);
+        tessellator.addVertexWithUV(xSize, ySize, -90D, uMax, vMax);
+        tessellator.addVertexWithUV(xSize, 0.0D, -90D, uMax, vMin);
+        tessellator.addVertexWithUV(0.0D, 0.0D, -90D, uMin, vMin);
         tessellator.draw();
         GLRenderer.setDepthMask(true);
         GLRenderer.enableState(State.DEPTH_TEST);
